Index: palm/trunk/SOURCE/disturb_field.f90
===================================================================
--- palm/trunk/SOURCE/disturb_field.f90	(revision 4901)
+++ palm/trunk/SOURCE/disturb_field.f90	(revision 1)
@@ -1,47 +1,44 @@
-!> @file disturb_field.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
+ SUBROUTINE disturb_field( nzb_uv_inner, dist1, field, xrp, ynp )
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
+! -----------------
+! 
 !
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
-! ------------------
-! 
-! 
 ! Former revisions:
 ! -----------------
-! $Id$
-! file re-formatted to follow the PALM coding standard
+! $Log: disturb_field.f90,v $
+! Revision 1.11  2006/08/04 14:31:59  raasch
+! izuf renamed iran
 !
-! 4457 2020-03-11 14:20:43Z raasch
-! use statement for exchange horiz added
+! Revision 1.10  2006/02/23 12:14:06  raasch
+! Additional argument nzb_uv_inner (no perturbations below the topography)
 !
-! 4360 2020-01-07 11:25:50Z suehring
-! Introduction of wall_flags_total_0, which currently sets bits based on static topography
-! information used in wall_flags_static_0
+! Revision 1.9  2005/03/26 20:18:30  raasch
+! Arguments for non-cyclic boundary conditions added to argument list and to
+! argument list of routine exchange_horiz.
+! Perturbations can be imposed for different ranges (steered by dist_range).
 !
-! 4329 2019-12-10 15:46:36Z motisi
-! Renamed wall_flags_0 to wall_flags_static_0
+! Revision 1.8  2003/10/29 08:48:51  raasch
+! Module random_function_mod is used
 !
-! 4237 2019-09-25 11:33:42Z knoop
-! Added missing OpenMP directives
+! Revision 1.7  2003/03/14 13:41:48  raasch
+! Different random number generators available
 !
-! 4182 2019-08-22 15:20:23Z scharf
-! Corrected "Former revisions" section
+! Revision 1.6  2001/03/30 07:22:26  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.)
 !
-! 3849 2019-04-01 16:35:16Z knoop
-! Corrected "Former revisions" section
+! Revision 1.5  2001/01/25 06:59:38  raasch
+! Module interfaces added (missing this interface caused errors on machines
+! other than Cray)
+!
+! Revision 1.4  2001/01/22 06:32:49  raasch
+! Module test_variables removed
+!
+! Revision 1.3  2000/07/03 12:59:03  raasch
+! All comments translated into English
+!
+! Revision 1.2  1998/07/06 12:13:01  raasch
+! + USE test_variables
 !
 ! Revision 1.1  1998/02/04 15:40:45  raasch
@@ -51,67 +48,37 @@
 ! Description:
 ! ------------
-!> Imposing a random perturbation on a 3D-array.
-!> On parallel computers, the random number generator is as well called for all gridpoints of the
-!> total domain to ensure, regardless of the number of PEs used, that the elements of the array have
-!> the same values in the same order in every case. The perturbation range is steered by dist_range.
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE disturb_field( var_char, dist1, field )
+! Imposing a random perturbation on a 3D-array.
+! On parallel computers, the random number generator is as well called for all
+! gridpoints of the total domain to ensure, regardless of the number of PEs
+! used, that the elements of the array have the same values in the same
+! order in every case. The perturbation range is steered by dist_range.
+!------------------------------------------------------------------------------!
 
-
-    USE control_parameters,                                                                        &
-        ONLY:  dist_nxl, dist_nxr, dist_nyn, dist_nys, dist_range, disturbance_amplitude,          &
-               disturbance_created, disturbance_level_ind_b, disturbance_level_ind_t, iran,        &
-               random_generator, topography
-
-    USE cpulog,                                                                                    &
-        ONLY:  cpu_log, log_point
-
-    USE exchange_horiz_mod,                                                                        &
-        ONLY:  exchange_horiz
-
-    USE indices,                                                                                   &
-        ONLY:  nbgp, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzb_max, nzt,                &
-               wall_flags_total_0
-
-    USE kinds
-
-    USE random_function_mod,                                                                       &
-        ONLY: random_function
-
-    USE random_generator_parallel,                                                                 &
-        ONLY:  random_number_parallel, random_seed_parallel, random_dummy, seq_random_array
+    USE control_parameters
+    USE cpulog
+    USE grid_variables
+    USE indices
+    USE interfaces
+    USE random_function_mod
 
     IMPLICIT NONE
 
-    CHARACTER (LEN = *) ::  var_char !< flag to distinguish betwenn u- and v-component
+    INTEGER ::  i, j, k, xrp, ynp
+    INTEGER ::  nzb_uv_inner(nys-1:nyn+1,nxl-1:nxr+1)
 
-    INTEGER(iwp) ::  flag_nr !< number of respective flag for u- or v-grid
-    INTEGER(iwp) ::  i       !< index variable
-    INTEGER(iwp) ::  j       !< index variable
-    INTEGER(iwp) ::  k       !< index variable
-
-    REAL(wp) ::  randomnumber  !<
-
-    REAL(wp) ::  dist1(nzb:nzt+1,nysg:nyng,nxlg:nxrg)  !<
-    REAL(wp) ::  field(nzb:nzt+1,nysg:nyng,nxlg:nxrg)  !<
-
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  dist2  !<
+    REAL    ::  randomnumber,                             &
+                dist1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
+                field(nzb:nzt+1,nys-1:nyn+ynp+1,nxl-1:nxr+xrp+1)
+    REAL, DIMENSION(:,:,:), ALLOCATABLE ::  dist2
 
 
     CALL cpu_log( log_point(20), 'disturb_field', 'start' )
-!
-!-- Set flag number, 20 for u-grid, 21 for v-grid, required to mask topography
-    flag_nr = MERGE( 20, 21, TRIM(var_char) == 'u' )
-!
-!-- Create an additional temporary array and initialize the arrays needed to store the disturbance
-    ALLOCATE( dist2(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-!$ACC DATA CREATE(dist2(nzb:nzt+1,nysg:nyng,nxlg:nxrg))
 
 !
-!-- dist1 is initialized on the host (see below) and then updated on the device.
-    dist1 = 0.0_wp
-    !$ACC KERNELS PRESENT(dist2)
-    dist2 = 0.0_wp
-    !$ACC END KERNELS
+!-- Create an additional temporary array and initialize the arrays needed
+!-- to store the disturbance
+    ALLOCATE( dist2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+    dist1 = 0.0
+    dist2 = 0.0
 
 !
@@ -121,23 +88,12 @@
           DO  j = dist_nys(dist_range), dist_nyn(dist_range)
              DO  k = disturbance_level_ind_b, disturbance_level_ind_t
-                randomnumber = 3.0_wp * disturbance_amplitude * ( random_function( iran ) - 0.5_wp )
-                IF ( nxl <= i  .AND.  nxr >= i  .AND.  nys <= j  .AND. nyn >= j )  THEN
+                randomnumber = 3.0 * disturbance_amplitude * &
+                               ( random_function( iran ) - 0.5 )
+                IF ( nxl <= i  .AND.  nxr >= i  .AND.  nys <= j  .AND.  &
+                     nyn >= j ) &
+                THEN
                    dist1(k,j,i) = randomnumber
                 ENDIF
              ENDDO
-          ENDDO
-       ENDDO
-    ELSEIF ( random_generator == 'random-parallel' )  THEN
-       DO  i = dist_nxl(dist_range), dist_nxr(dist_range)
-          DO  j = dist_nys(dist_range), dist_nyn(dist_range)
-             CALL random_seed_parallel( put=seq_random_array(:, j, i) )
-             DO  k = disturbance_level_ind_b, disturbance_level_ind_t
-                CALL random_number_parallel( random_dummy )
-                randomnumber = 3.0_wp * disturbance_amplitude * ( random_dummy - 0.5_wp )
-                IF ( nxl <= i  .AND.  nxr >= i  .AND.  nys <= j  .AND.  nyn >= j )  THEN
-                   dist1(k,j,i) = randomnumber
-                ENDIF
-             ENDDO
-             CALL random_seed_parallel( get=seq_random_array(:, j, i) )
           ENDDO
        ENDDO
@@ -146,7 +102,14 @@
           DO  j = dist_nys(dist_range), dist_nyn(dist_range)
              DO  k = disturbance_level_ind_b, disturbance_level_ind_t
+#if defined( __nec )
+                randomnumber = 3.0 * disturbance_amplitude * &
+                               ( RANDOM( 0 ) - 0.5 )
+#else
                 CALL RANDOM_NUMBER( randomnumber )
-                randomnumber = 3.0_wp * disturbance_amplitude * ( randomnumber - 0.5_wp )
-                IF ( nxl <= i  .AND.  nxr >= i  .AND.  nys <= j  .AND.  nyn >= j )  THEN
+                randomnumber = 3.0 * disturbance_amplitude * &
+                                ( randomnumber - 0.5 )
+#endif
+                IF ( nxl <= i .AND. nxr >= i .AND. nys <= j .AND. nyn >= j ) &
+                THEN
                    dist1(k,j,i) = randomnumber
                 ENDIF
@@ -158,63 +121,46 @@
 
 !
-!-- Update dist1 on the device, this is expected by exchange_horiz!
-    !$ACC UPDATE DEVICE(dist1(nzb:nzt+1,nysg:nyng,nxlg:nxrg))
+!-- Exchange of ghost points for the random perturbation
+    CALL exchange_horiz( dist1, 0, 0 )
 
 !
-!-- Exchange of ghost points for the random perturbation
-
-    CALL exchange_horiz( dist1, nbgp )
-!
 !-- Applying the Shuman filter in order to smooth the perturbations.
-!-- Neighboured grid points in all three directions are used for the filter operation.
-!-- Loop has been splitted to make runs reproducible on HLRN systems using compiler option -O3
-     !$ACC PARALLEL LOOP COLLAPSE(2) PRIVATE(i, j, k) PRESENT(dist1, dist2)
-     !$OMP PARALLEL DO PRIVATE(i, j, k)
-     DO  i = nxl, nxr
-        DO  j = nys, nyn
+!-- Neighboured grid points in all three directions are used for the
+!-- filter operation.
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
           DO  k = disturbance_level_ind_b-1, disturbance_level_ind_t+1
-             dist2(k,j,i) = ( dist1(k,j,i-1) + dist1(k,j,i+1)                                      &
-                            + dist1(k,j+1,i) + dist1(k+1,j,i)                                      &
-                            ) / 12.0_wp
+             dist2(k,j,i) = ( dist1(k,j,i-1) + dist1(k,j,i+1) + dist1(k,j-1,i) &
+                            + dist1(k,j+1,i) + dist1(k+1,j,i) + dist1(k-1,j,i) &
+                            + 6.0 * dist1(k,j,i)                               &
+                            ) / 12.0
           ENDDO
-          DO  k = disturbance_level_ind_b-1, disturbance_level_ind_t+1
-              dist2(k,j,i) = dist2(k,j,i) + ( dist1(k,j-1,i) + dist1(k-1,j,i)                      &
-                            + 6.0_wp * dist1(k,j,i)                                                &
-                                            ) / 12.0_wp
-          ENDDO
-        ENDDO
-     ENDDO
+       ENDDO
+    ENDDO
 
 !
 !-- Exchange of ghost points for the filtered perturbation.
 !-- Afterwards, filter operation and exchange of ghost points are repeated.
-    CALL exchange_horiz( dist2, nbgp )
-
-    !$ACC PARALLEL LOOP COLLAPSE(2) PRIVATE(i, j, k) PRESENT(dist1, dist2)
-    !$OMP PARALLEL DO PRIVATE(i, j, k)
+    CALL exchange_horiz( dist2, 0, 0 )
     DO  i = nxl, nxr
        DO  j = nys, nyn
           DO  k = disturbance_level_ind_b-2, disturbance_level_ind_t+2
-             dist1(k,j,i) = ( dist2(k,j,i-1) + dist2(k,j,i+1) + dist2(k,j-1,i)                     &
-                            + dist2(k,j+1,i) + dist2(k+1,j,i) + dist2(k-1,j,i)                     &
-                            + 6.0_wp * dist2(k,j,i)                                                &
-                            ) / 12.0_wp
+             dist1(k,j,i) = ( dist2(k,j,i-1) + dist2(k,j,i+1) + dist2(k,j-1,i) &
+                            + dist2(k,j+1,i) + dist2(k+1,j,i) + dist2(k-1,j,i) &
+                            + 6.0 * dist2(k,j,i)                               &
+                            ) / 12.0
           ENDDO
        ENDDO
     ENDDO
-
-    CALL exchange_horiz( dist1, nbgp )
+    CALL exchange_horiz( dist1, 0, 0 )
 
 !
-!-- Remove perturbations below topography (including one gridpoint above it in order to allow for
-!-- larger timesteps at the beginning of the simulation (diffusion criterion))
+!-- Remove perturbations below topography (including one gridpoint above it
+!-- in order to allow for larger timesteps at the beginning of the simulation
+!-- (diffusion criterion))
     IF ( TRIM( topography ) /= 'flat' )  THEN
-       DO  i = nxlg, nxrg
-          DO  j = nysg, nyng
-             DO  k = nzb, nzb_max
-                dist1(k,j,i) = MERGE( dist1(k,j,i), 0.0_wp,                                        &
-                                  BTEST( wall_flags_total_0(k,j,i), flag_nr )                      &
-                                    )
-             ENDDO
+       DO  i = nxl-1, nxr+1
+          DO  j = nys-1, nyn+1
+             dist1(nzb:nzb_uv_inner(j,i)+1,j,i) = 0.0
           ENDDO
        ENDDO
@@ -223,8 +169,6 @@
 !
 !-- Random perturbation is added to the array to be disturbed.
-    !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) PRESENT(field, dist1)
-    !$OMP PARALLEL DO PRIVATE(i, j, k)
-    DO  i = nxlg, nxrg
-       DO  j = nysg, nyng
+    DO  i = nxl-1, nxr+1
+       DO  j = nys-1, nyn+1
           DO  k = disturbance_level_ind_b-2, disturbance_level_ind_t+2
              field(k,j,i) = field(k,j,i) + dist1(k,j,i)
@@ -232,6 +176,4 @@
        ENDDO
     ENDDO
-
-!$ACC END DATA
 
 !
Index: palm/trunk/SOURCE/disturb_heatflux.f90
===================================================================
--- palm/trunk/SOURCE/disturb_heatflux.f90	(revision 4901)
+++ palm/trunk/SOURCE/disturb_heatflux.f90	(revision 1)
@@ -1,38 +1,30 @@
-!> @file disturb_heatflux.f90
+ SUBROUTINE disturb_heatflux
+
 !------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
+! Actual revisions:
+! -----------------
+! 
 !
-! PALM is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!------------------------------------------------------------------------------!
-!
-! Current revisions:
-! ------------------
-! 
-! 
 ! Former revisions:
 ! -----------------
-! $Id$
-! Corrected "Former revisions" section
-! 
-! 3761 2019-02-25 15:31:42Z raasch
-! unsed variables removed
-! 
-! 3719 2019-02-06 13:10:18Z kanani
-! Moved log_points out of subroutine into time_integration for better overview.
-! 
-! 3655 2019-01-07 16:51:22Z knoop
-! unused variable removed
+! $Log: disturb_heatflux.f90,v $
+! Revision 1.7  2006/08/04 14:35:07  raasch
+! Additional parameter in function random_gauss which limits the range of the
+! created random numbers, izuf renamed iran
+!
+! Revision 1.6  2006/02/23 12:14:38  raasch
+! Over topography surface_heatflux is replaced by wall_heatflux(0)
+!
+! Revision 1.5  2001/03/30 07:22:44  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.4  2001/01/22 06:34:34  raasch
+! Module test_variables removed
+!
+! Revision 1.3  2000/12/20 11:57:38  letzel
+! All comments translated into English.
+!
+! Revision 1.2  1998/07/06 12:13:19  raasch
+! + USE test_variables
 !
 ! Revision 1.1  1998/03/25 20:03:47  raasch
@@ -42,89 +34,49 @@
 ! Description:
 ! ------------
-!> Generate random, normally distributed heatflux values and store them as the
-!> near-surface heatflux.
+! Generate random, normally distributed heatflux values and store them as the
+! near-surface heatflux.
+! On parallel computers, too, this random generator is called at all grid points
+! of the total array in order to guarantee the same random distribution of the
+! total array regardless of the number of processors used during the model run.
 !------------------------------------------------------------------------------!
- SUBROUTINE disturb_heatflux( surf )
- 
 
-    USE arrays_3d,                                                             &
-        ONLY:  heatflux_input_conversion
-        
-    USE control_parameters,                                                    &
-        ONLY:  iran, surface_heatflux, random_generator, wall_heatflux
-        
-    USE kinds
-    
-    USE indices,                                                               &
-        ONLY:  nzb
-
-    USE random_generator_parallel,                                             &
-        ONLY:  random_number_parallel, random_seed_parallel, random_dummy,     &
-               seq_random_array
-
-    USE surface_mod,                                                           &
-        ONLY:  surf_type
+    USE arrays_3d
+    USE control_parameters
+    USE cpulog
+    USE grid_variables
+    USE indices
+    USE interfaces
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i  !< grid index, x direction
-    INTEGER(iwp) ::  j  !< grid index, y direction
-    INTEGER(iwp) ::  k  !< grid index, z direction
-    INTEGER(iwp) ::  m  !< loop variables over surface elements
-    
-    REAL(wp) ::  random_gauss  !<
-    REAL(wp) ::  randomnumber  !<
-
-    TYPE(surf_type) ::  surf   !< surface-type variable
+    INTEGER ::  i, j
+    REAL    ::  random_gauss, randomnumber
 
 
+    CALL cpu_log( log_point(23), 'disturb_heatflux', 'start' )
+
 !
-!-- Generate random disturbances and store them. Note, if 
-!-- random_generator /= 'random-parallel' it is not guaranteed to obtain  
-!-- the same random distribution if the number of processors is changed. 
-    IF ( random_generator /= 'random-parallel' )  THEN
-
-       DO  m = 1, surf%ns
-
-          k = surf%k(m)
-
-          randomnumber = random_gauss( iran, 5.0_wp )      
+!-- Generate random disturbances and store them
+    DO  i = 0, nx
+       DO  j = 0, ny
+          randomnumber = random_gauss( iran, 5.0 )
+          IF ( nxl <= i  .AND.  nxr >= i  .AND.  nys <= j  .AND.  nyn >= j ) &
+          THEN
+             IF ( nzb_s_inner(j,i) == 0 )  THEN
+                shf(j,i) = randomnumber * surface_heatflux
 !
-!--       k-1 is topography top index. If this is 0, set surface heatflux. Over
-!--       topography surface_heatflux is replaced by wall_heatflux(0).
-          IF ( k-1 == 0 )  THEN
-             surf%shf(m) = randomnumber * surface_heatflux                     &
-                              * heatflux_input_conversion(nzb)
-          ELSE
-             surf%shf(m) = randomnumber * wall_heatflux(0)                     &
-                              * heatflux_input_conversion(k-1)
+!--             Over topography surface_heatflux is replaced by wall_heatflux(0)
+                shf(j,i) = randomnumber * wall_heatflux(0)
+             ELSE
+             ENDIF
           ENDIF
        ENDDO
-    ELSE
+    ENDDO
 
-       DO  m = 1, surf%ns
+!
+!-- Exchange lateral boundary conditions for the heatflux array
+    CALL exchange_horiz_2d( shf )
 
-          i = surf%i(m)
-          j = surf%j(m)
-          k = surf%k(m)
-
-          CALL random_seed_parallel( put=seq_random_array(:, j, i) )
-          CALL random_number_parallel( random_dummy )    
-!
-!--       k-1 is topography top index. If this is 0, set surface heatflux. Over
-!--       topography surface_heatflux is replaced by wall_heatflux(0).
-          IF ( k-1 == 0 )  THEN
-             surf%shf(m) = ( random_dummy - 0.5_wp ) * surface_heatflux        &
-                              * heatflux_input_conversion(nzb)
-          ELSE
-             surf%shf(m) = ( random_dummy - 0.5_wp ) * wall_heatflux(0)        &
-                              * heatflux_input_conversion(k-1)
-          ENDIF
-
-          CALL random_seed_parallel( get=seq_random_array(:, j, i) )
-
-       ENDDO
-
-    ENDIF
+    CALL cpu_log( log_point(23), 'disturb_heatflux', 'stop' )
 
 
Index: palm/trunk/SOURCE/exchange_horiz.f90
===================================================================
--- palm/trunk/SOURCE/exchange_horiz.f90	(revision 1)
+++ palm/trunk/SOURCE/exchange_horiz.f90	(revision 1)
@@ -0,0 +1,180 @@
+ SUBROUTINE exchange_horiz( ar, xrp, ynp )
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
+! -----------------
+! 
+!
+! Former revisions:
+! -----------------
+! $Log: exchange_horiz.f90,v $
+! Revision 1.16  2006/02/23 12:19:08  raasch
+! anz_yz renamed ngp_yz
+!
+! Revision 1.15  2005/03/26 20:20:39  raasch
+! Extensions for non-cyclic boundary conditions along x or y
+!
+! Revision 1.14  2003/10/29 08:51:10  raasch
+! Exchange of boundaries within the PE memory in case that multigrid method
+! has switched to PE0 only
+!
+! Revision 1.13  2003/03/16 09:30:38  raasch
+! Two underscores (_) are placed in front of all define-strings
+!
+! Revision 1.12  2002/12/20 10:40:08  raasch
+! Integer variables will be defined in the parallel case only
+!
+! Revision 1.11  2002/12/19 14:46:43  raasch
+! Cyclic boundary conditions along y used instead of sendrecv in case of
+! pdims(2)=1. SENDRECV replaced by nonblocking routines ISEND and IRECV.
+! Array "feld" is renamed to "ar".
+!
+! Revision 1.9  2002/04/16  08:16:50  08:16:50  raasch (Siegfried Raasch)
+! Cyclic boundary conditions along x used instead of sendrecv in case of
+! pdims(1)=1
+! 
+! Revision 1.8  2001/07/20 13:04:59  raasch
+! anz_yz and type_xz changed to arrays to allow for the boundary value exchange
+! for the different grid levels used in the multigrid method,
+! +module control_parameters
+!
+! Revision 1.7  2001/03/30 07:23:00  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.6  2001/01/22 06:36:07  raasch
+! Module test_variables removed
+!
+! Revision 1.5  2000/12/20 12:06:44  letzel
+! All comments translated into English.
+!
+! Revision 1.4  1998/07/06 12:13:36  raasch
+! + USE test_variables
+!
+! Revision 1.3  1998/01/23 09:57:45  raasch
+! Umbenennung von anz_yz_p in anz_yz sowie von type_xz_p in type_xz
+!
+! Revision 1.2  1997/08/11 06:14:55  raasch
+! Felder werden jetzt ueber Formalparameter uebergeben.
+!
+! Revision 1.1  1997/07/24 11:13:29  raasch
+! Initial revision
+!
+!
+! Description:
+! ------------
+! Exchange of lateral boundary values (parallel computers) and cyclic
+! lateral boundary conditions, respectively.
+!------------------------------------------------------------------------------!
+
+    USE control_parameters
+    USE cpulog
+    USE indices
+    USE interfaces
+    USE pegrid
+
+    IMPLICIT NONE
+
+    INTEGER ::  xrp, ynp
+
+#if defined( __parallel )
+    INTEGER                               ::  typexz
+    INTEGER, DIMENSION(4)                 ::  req
+    INTEGER, DIMENSION(MPI_STATUS_SIZE,4) ::  wait_stat
+#endif
+
+    REAL ::  ar(nzb:nzt+1,nys-1:nyn+ynp+1,nxl-1:nxr+xrp+1)
+
+
+    CALL cpu_log( log_point_s(2), 'exchange_horiz', 'start' )
+
+#if defined( __parallel )
+
+!
+!-- Exchange of lateral boundary values for parallel computers
+    IF ( pdims(1) == 1  .OR.  mg_switch_to_pe0 )  THEN
+!
+!--    One-dimensional decomposition along y, boundary values can be exchanged
+!--    within the PE memory
+       IF ( bc_lr == 'cyclic' )  THEN
+          ar(:,nys:nyn,nxl-1) = ar(:,nys:nyn,nxr)
+          ar(:,nys:nyn,nxr+1) = ar(:,nys:nyn,nxl)
+       ENDIF
+
+    ELSE
+       req = 0
+!
+!--    Send left boundary, receive right one
+       CALL MPI_ISEND(                                                     &
+               ar(nzb,nys-1,nxl), ngp_yz(grid_level), MPI_REAL, pleft,  0, &
+                          comm2d, req(1), ierr )
+       CALL MPI_IRECV(                                                       &
+               ar(nzb,nys-1,nxr+1), ngp_yz(grid_level), MPI_REAL, pright, 0, &
+                          comm2d, req(2), ierr )
+!
+!--    Send right boundary, receive left one
+       CALL MPI_ISEND(                                                     &
+               ar(nzb,nys-1,nxr), ngp_yz(grid_level), MPI_REAL, pright, 1, &
+                          comm2d, req(3), ierr )
+       CALL MPI_IRECV(                                                       &
+               ar(nzb,nys-1,nxl-1), ngp_yz(grid_level), MPI_REAL, pleft,  1, &
+                          comm2d, req(4), ierr )
+       call MPI_Waitall (4,req,wait_stat,ierr)
+    ENDIF
+
+
+    IF ( pdims(2) == 1  .OR.  mg_switch_to_pe0 )  THEN
+!
+!--    One-dimensional decomposition along x, boundary values can be exchanged
+!--    within the PE memory
+       IF ( bc_ns == 'cyclic' )  THEN
+          ar(:,nys-1,:) = ar(:,nyn,:)
+          ar(:,nyn+1,:) = ar(:,nys,:)
+       ENDIF
+
+    ELSE
+!
+!--    Set the MPI data type, which depends on the size of the array
+!--    (the v array has an additional gridpoint along y in case of non-cyclic
+!--    boundary conditions)
+       IF ( ynp == 0 )  THEN
+          typexz = type_xz(grid_level)
+       ELSE
+          typexz = type_xz_p
+       ENDIF
+
+       req = 0
+!
+!--    Send front boundary, receive rear one
+       CALL MPI_ISEND( ar(nzb,nys,nxl-1),   1, typexz, psouth, 0, comm2d, &
+                       req(1), ierr )
+       CALL MPI_IRECV( ar(nzb,nyn+1,nxl-1), 1, typexz, pnorth, 0, comm2d, &
+                       req(2), ierr )
+!
+!--    Send rear boundary, receive front one
+       CALL MPI_ISEND( ar(nzb,nyn,nxl-1),   1, typexz, pnorth, 1, comm2d, &
+                       req(3), ierr )
+       CALL MPI_IRECV( ar(nzb,nys-1,nxl-1), 1, typexz, psouth, 1, comm2d, &
+                       req(4), ierr )
+       call MPI_Waitall (4,req,wait_stat,ierr)
+    ENDIF
+
+
+#else
+
+!
+!-- Lateral boundary conditions in the non-parallel case
+    IF ( bc_lr == 'cyclic' )  THEN
+       ar(:,nys:nyn,nxl-1) = ar(:,nys:nyn,nxr)
+       ar(:,nys:nyn,nxr+1) = ar(:,nys:nyn,nxl)
+    ENDIF
+
+    IF ( bc_ns == 'cyclic' )  THEN
+       ar(:,nys-1,:) = ar(:,nyn,:)
+       ar(:,nyn+1,:) = ar(:,nys,:)
+    ENDIF
+
+#endif
+
+    CALL cpu_log( log_point_s(2), 'exchange_horiz', 'stop' )
+
+ END SUBROUTINE exchange_horiz
